using Foundation;
using System;
using System.CodeDom.Compiler;
using UIKit;
using Syncfusion.SfDataGrid;
using CoreGraphics;

namespace PlataformaSage.Financas.M.iOS
{
	partial class UISaldoBancarioDetalhesViewController : UIViewController
	{
        SfDataGrid sfGrid;
        GridTextColumn vColunaGrid_Conta;
        GridTextColumn vColunaGrid_Saldo;

        public UISaldoBancarioDetalhesViewController (IntPtr handle) : base (handle)
		{
            sfGrid = new SfDataGrid();

            //>>>> DataGridSaldoBancarioUIView is a simple view inside the default view, that will host the sfDataGrid

            sfGrid.AutoGenerateColumns = false;
            vColunaGrid_Conta = new GridTextColumn();
            vColunaGrid_Conta.MappingName = "DetalhesSaldoBancario_Conta";
            vColunaGrid_Conta.HeaderText = "Conta";
            vColunaGrid_Conta.TextAlignment = UITextAlignment.Left;
            vColunaGrid_Conta.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.75;
            sfGrid.Columns.Add(vColunaGrid_Conta);

            vColunaGrid_Saldo = new GridTextColumn();
            vColunaGrid_Saldo.MappingName = "DetalhesSaldoBancario_Saldo";
            vColunaGrid_Saldo.HeaderText = "Saldo";
            vColunaGrid_Saldo.TextAlignment = UITextAlignment.Right;
            vColunaGrid_Saldo.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.25;
            sfGrid.Columns.Add(vColunaGrid_Saldo);

            sfGrid.ItemsSource = (new DetalheSaldoBancarioRepositorio().OrderInfoCollection);            
            
            sfGrid.HeaderRowHeight = 30;
            sfGrid.RowHeight = 28;            
            
            sfGrid.QueryRowHeight += QueryRowHeight;            

            sfGrid.BackgroundColor = UIColor.Blue;            
		}

        
        void QueryRowHeight(object sender, QueryRowHeightEventArgs e)
        {
            if (e.RowIndex > 0)
            {                 
                double height = SfDataGridHelpers.GetRowHeight(sfGrid, e.RowIndex);                
                if (height > 60)
                {
                    e.Height = height - 30;
                    e.Handled = true;
                }
            }
        }

        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();

            DataGridStyle vEstiloDoDataGrid = new DataGridStyle();
            vEstiloDoDataGrid.HeaderBackground = UIColor.Clear.FromHexString(PlataformaSage.Financas.Classes.Constantes.COR_HEX_VERDE_HEADERGRID);
            vEstiloDoDataGrid.HeaderForeground = UIColor.White;
            vEstiloDoDataGrid.CellForeground = UIColor.Clear.FromHexString(PlataformaSage.Financas.Classes.Constantes.COR_HEX_TEXTO);
            vEstiloDoDataGrid.CellBackground = UIColor.Clear.FromHexString(PlataformaSage.Financas.Classes.Constantes.COR_HEX_BACKGROUNDGRID);
            sfGrid.GridStyle = vEstiloDoDataGrid;
            
            vColunaGrid_Conta.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.65;
            vColunaGrid_Saldo.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.35;

            sfGrid.Frame = DataGridSaldoBancarioUIView.Frame;            
        }

        
        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            View.AddSubview(sfGrid);
        }

        
        public override void ViewDidDisappear(bool animated)
        {
            base.ViewDidDisappear(animated);            
            this.sfGrid.Dispose();
            this.sfGrid = null;
        }
	}
}
